commit:     4fe95a37874a698ade76b7677d750822bc7ea356
Author:     Alfred Wingate <parona <AT> protonmail <DOT> com>
AuthorDate: Sat May 24 18:21:43 2025 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Sat May 24 18:41:18 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=4fe95a37

dev-python/pyopencl: add 2025.1

Bug: https://bugs.gentoo.org/952374
Closes: https://bugs.gentoo.org/956365
Signed-off-by: Alfred Wingate <parona <AT> protonmail.com>
Part-of: https://github.com/gentoo/gentoo/pull/42242
Closes: https://github.com/gentoo/gentoo/pull/42242
Signed-off-by: Sam James <sam <AT> gentoo.org>

 dev-python/pyopencl/Manifest                       |  1 +
 .../files/pyopencl-2025.1-nanobind-flags.patch     | 21 ++++++
 dev-python/pyopencl/pyopencl-2025.1.ebuild         | 78 ++++++++++++++++++++++
 3 files changed, 100 insertions(+)

diff --git a/dev-python/pyopencl/Manifest b/dev-python/pyopencl/Manifest
index 456e0cba7bba..354ea28a50d8 100644
--- a/dev-python/pyopencl/Manifest
+++ b/dev-python/pyopencl/Manifest
@@ -1 +1,2 @@
 DIST pyopencl-2024.2.7.tar.gz 470964 BLAKE2B 
6c61d91735667dd63fec0375defe98fb681eb448780f86b0129769d30714adb51832955d8c2e838970f17187e5027f794cd21affc870910d23ec46126049d4ed
 SHA512 
5c9982f5dcaeb3faeb6ac6b88940b5baff43b7580fc5d466a596d9c180e45725cbf9971ba6ae4981202900b06cee3be7fa88fdf7227befee874a8f203a3a3267
+DIST pyopencl-2025.1.tar.gz 422510 BLAKE2B 
1da270b4eabd3cf1209c97db6383ccd3450601946181386c139ed76b9cee3cccba06d6836b342b902fb227d1ef43f899633fe2037f5744a38b37677ef70ed00c
 SHA512 
bc281c38b977f207a213763aca3c0086430e5a4d8d9018673fb5648e1afc440758ec7ec219544644d596805beaa448b2fa34cd5b4c109a46b3d6e8b7648a931c

diff --git a/dev-python/pyopencl/files/pyopencl-2025.1-nanobind-flags.patch 
b/dev-python/pyopencl/files/pyopencl-2025.1-nanobind-flags.patch
new file mode 100644
index 000000000000..6f7c7cff1462
--- /dev/null
+++ b/dev-python/pyopencl/files/pyopencl-2025.1-nanobind-flags.patch
@@ -0,0 +1,21 @@
+nanobind defaults to adding -Os and friends: 
https://github.com/wjakob/nanobind/blob/b0136fe6ac1967cb2399456adc346a1af06a3b88/docs/api_cmake.rst#L80.
+
+... and LTO should be user defined via cflags.
+
+--- a/CMakeLists.txt
+diff --git a/CMakeLists.txt b/CMakeLists.txt
+index 4557bd8a..0f4a731c 100644
+--- a/CMakeLists.txt
++++ b/CMakeLists.txt
+@@ -167,8 +167,9 @@ find_package(OpenCL REQUIRED)
+ nanobind_add_module(
+   _cl
+   NB_STATIC # Build static libnanobind (the extension module itself remains a 
shared library)
+-  LTO
++  PROTECT_STACK
+   NOMINSIZE
++  NOSTRIP
+   src/wrap_constants.cpp
+   src/wrap_cl.cpp
+   src/wrap_cl_part_1.cpp
+

diff --git a/dev-python/pyopencl/pyopencl-2025.1.ebuild 
b/dev-python/pyopencl/pyopencl-2025.1.ebuild
new file mode 100644
index 000000000000..dd31efaa69d1
--- /dev/null
+++ b/dev-python/pyopencl/pyopencl-2025.1.ebuild
@@ -0,0 +1,78 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{10..13} )
+DISTUTILS_EXT=1
+DISTUTILS_USE_PEP517=scikit-build-core
+
+inherit distutils-r1 multiprocessing pypi
+
+DESCRIPTION="Python wrapper for OpenCL"
+HOMEPAGE="
+       https://mathema.tician.de/software/pyopencl/
+       https://pypi.org/project/pyopencl/
+"
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~amd64 ~ppc64 ~riscv"
+IUSE="examples opengl"
+
+# Running tests on GPUs requires both appropriate hardware and additional 
permissions
+# having been granted to the user running them. Testing on CPUs with 
dev-libs/pocl
+# is in theory possible but has been found to be very fragile, see e.g. Bug 
#872308.
+RESTRICT="test"
+
+COMMON=">=virtual/opencl-2"
+# libglvnd is only needed for the headers
+DEPEND="
+       ${COMMON}
+       opengl? ( media-libs/libglvnd )
+"
+RDEPEND="
+       ${COMMON}
+       >=dev-python/mako-0.3.6[${PYTHON_USEDEP}]
+       dev-python/numpy[${PYTHON_USEDEP}]
+       >=dev-python/platformdirs-2.2.0[${PYTHON_USEDEP}]
+       >=dev-python/pytools-2024.1.5[${PYTHON_USEDEP}]
+"
+BDEPEND="
+       dev-python/numpy[${PYTHON_USEDEP}]
+       dev-python/nanobind[${PYTHON_USEDEP}]
+       test? ( dev-libs/pocl )
+"
+
+PATCHES=(
+       "${FILESDIR}"/pyopencl-2025.1-nanobind-flags.patch
+)
+
+distutils_enable_tests pytest
+
+python_configure_all() {
+       DISTUTILS_ARGS=(
+               -DPYOPENCL_ENABLE_GL=$(usex opengl)
+       )
+}
+
+python_test() {
+       # Use dev-libs/pocl for testing; ignore any other OpenCL devices that 
might be present
+       local -x PYOPENCL_TEST="portable:cpu"
+       # Set the number of threads to match MAKEOPTS
+       local -x POCL_MAX_PTHREAD_COUNT=$(makeopts_jobs)
+       # Change to the 'test' directory so that python does not try to import 
pyopencl from the source directory
+       # (Importing from the source directory fails, because the compiled 
'_cl' module is only in the build directory)
+       pushd test >/dev/null || die
+       epytest
+       popd >/dev/null || die
+}
+
+python_install_all() {
+       if use examples; then
+               dodoc -r examples
+               docompress -x /usr/share/doc/${PF}/examples
+       fi
+
+       distutils-r1_python_install_all
+}

Reply via email to